/*
graph.h
*/

#include <stdlib.h>
#include <stdio.h>
#define uword unsigned short int
#define uchar unsigned char
#define WHITE 1
#define BLACK 0
#define MAX_COLOURS 90
#define LINEAR 0
#define LOGARITHMIC 1

typedef struct {
uword xsize,ysize,xoffs,yoffs,xaxissize,yaxissize;
unsigned char **raw,**pixel;
} Axes;
typedef struct {
uchar symbol[MAX_COLOURS];
uchar R[MAX_COLOURS],G[MAX_COLOURS],B[MAX_COLOURS];
uword ncolours;
} Colourmap;


int GraphCreateAxes(Axes *axes,uword xsize,uword ysize,uword xoffs,uword yoffs,uword xaxissize,uword yaxissize);
int GraphFreeAxes(Axes *axes);
int GraphDrawPixel(Axes *axes,uword x,uword y,char colour);
int GraphDrawHLine(Axes *axes,uword xstart,uword ystart,uword length,char colour);
int GraphDrawVLine(Axes *axes,uword xstart,uword ystart,uword length,char colour);
int GraphHText(Axes *axes,uword xstart,uword ystart,char * text);
int GraphVText(Axes *axes,uword xstart,uword ystart,char * text);
int GraphXTick(Axes *axes,uword x,short int length,char *text);
int GraphYTick(Axes *axes,uword y,short int length,char *text);
int GraphWriteXpm(Axes *axes,Colourmap *map,FILE * file,char * name);
int GraphCreateColourmap(Colourmap *map,uword ncolours);
int GraphDrawVColourbar(Axes *axes,Colourmap *map,uword x,uword y,uword width,uword height,float min,float max,float step,char * format,uchar scale);
int GraphCreateJet(Colourmap *map);
int GraphCreateLitmus(Colourmap *map);


