function [u,v]=reso(vel1,vel2,azim1,azim2)
%[u,v]=reso(vel1,vel2,azim1,azim2)
%resolves velocity components from two azimuths to give u and v components
% To use it, make sure that the two RHIs have been projected onto the
% same section. Typically, vel1 etc will be arrays created using, for
% example, minterp

%azim1=azim1+90;
%azim2=azim2+90;

alpha=azim1*pi/180-pi;
beta=azim2*pi/180-pi;

x0a=vel1.*sin(alpha);
y0a=vel1.*cos(alpha);
x0b=vel2.*sin(beta);
y0b=vel2.*cos(beta);

u=x0b.*tan(beta)-x0a.*tan(alpha)+y0b-y0a;
u=u./(tan(beta)-tan(alpha));
v=y0a-(u-x0a).*tan(alpha);
