function vs=smooth2d(v,small1,small2)

%smooth2d(v,small1,smooth2): Smooths v using 9-point average
% Use: vs=smooth2(v,small1,small2)
% small1 is the degree of smoothing in the first dimension (normally range)
% small2 is the degree of smoothing in the second dimension (normally elev)
% (ie the relative contribution from each surrounding point,
% relative to the central point.
if ( small1>0.01 | small2>0.01 )

[mm nn]=size(v);

disp(['mm = ' num2str(mm) '         nn = ' num2str(nn) ])
disp(['small1 = ' num2str(small1) '   small2 = ' num2str(small2) ])
vs1=v;

 n=1:nn;
 m=2:(mm-1);

vs1(m,n)=(v(m,n)+small1*(v(m-1,n)+v(m+1,n)))/(1+2.*small1);

 n=2:(nn-1);
 m=1:mm;

vs=vs1;
vs(m,n)=(vs1(m,n)+small2*(vs1(m,n-1)+vs1(m,n+1)))/(1+2.*small2);

 n=2:(nn-1);
 m=2:(mm-1);


 numnan=zeros(size(v));
 numnan(m,n)=isnan(v(m-1,n+1))+isnan(v(m,n+1))+isnan(v(m+1,n+1))+isnan(v(m-1,n))+isnan(v(m+1,n))+isnan(v(m-1,n-1))+isnan(v(m,n-1))+isnan(v(m+1,n-1));
 index=find(numnan ~= 0);
if ~isempty(index)
 vs(index)=v(index);
end
else
  vs=v;
end
