function [vel]=unf2(v)

%unf2(v): unfolds Doppler data
%v=v2;
maxvar=4;
lonely1=5;
lonely2=0;

[mm nn]=size(v);

vz=zap3(v,maxvar,lonely1,0);
vzn=vz;
mask=0*vz;

vf=30;

v0=0*(1:nn);

for i=1:mm,
	v1=vz(i,:);
	v1=v1+vf*2;
	v1=v1-vf*(v1>(v0+vf/2.0));
	v1=v1-vf*(v1>(v0+vf/2.0));
	v1=v1-vf*(v1>(v0+vf/2.0));
	v1=v1-vf*(v1>(v0+vf/2.0));

	vzn(i,:)=v1;

	ind=find(isnan(v1));
	if (isempty(ind)==0)
		v1(ind)=v0(ind);
	end

	mask(i,:)=v1;


	v0=v1;

end

nans=isnan(vz)==0;
vzn2=vzn;
index=find(isnan(vz));
vzn2(index)=zeros(size(index));
totals=sum(vzn2);
num=sum(nans);
means=totals./num;

means2=means;
nans2=isnan(means)==0;
index=find(isnan(means));
means2(index)=zeros(size(index));
totals2=sum(means2);
num2=sum(nans2);
mom=totals2/num2;

means(index)=mom*ones(size(index));

%use continuity in the means (neglecting NaNs) to adjust the result

offset=4+0*v;
m2=means;

for j=2:nn,
	d=[-3 -2 -1 0 1 2 3]*vf +means(j) - m2(j-1);
	ind=find(abs(d) == min(abs(d)));
	m2(j)=means(j)+(ind(1)-4)*vf;
	offset(:,j)=ind(1)*ones(size(offset(:,j)));
end

vzn2=vzn+(offset-4)*vf;

mask2=mask+(offset-4)*vf;

vel=unfold(v,mask2-0.5*vf);
